#include "wl_egl.h"
#include <stdio.h>

#include <QGuiApplication>
#include <qpa/qplatformnativeinterface.h>
#include <QDebug>
#include <QScreen>
#include <QWindow>
#include <QQuickWindow>
//#include <QOpenGLContext>
#include <QOpenGLFunctions>
#include <QGLFormat>
#include <QtWaylandClient/QWaylandClientExtension>
#include <EGL/egl.h>
//#include <gbm.h>
#include <EGL/eglplatform.h>
#include <wayland-client.h>
#include <errno.h>
#include <fcntl.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#define EGL_EGLEXT_PROTOTYPES
#define GL_GLEXT_PROTOTYPES
//#include <gbm.h>
#include <EGL/egl.h>
#include <EGL/eglext.h>
#include <drm_fourcc.h>
#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>
#include <xf86drm.h>
#include <xf86drmMode.h>
#include <wayland-client.h>
#include <wayland-server.h>
#include <wayland-client-protocol.h>
#include <wayland-egl.h>

static EGLDisplay m_display = nullptr;
static EGLConfig m_config = nullptr;
static EGLContext m_context = nullptr;
static PFNEGLCREATEIMAGEKHRPROC CreateImageKHR;
//static struct zwp_linux_dmabuf_v1 *dmabuf = nullptr;

static const char *get_egl_error()
{
    switch (eglGetError()) {
        case EGL_SUCCESS:
            return "EGL_SUCCESS";
        case EGL_NOT_INITIALIZED:
            return "EGL_NOT_INITIALIZED";
        case EGL_BAD_ACCESS:
            return "EGL_BAD_ACCESS";
        case EGL_BAD_ALLOC:
            return "EGL_BAD_ALLOC";
        case EGL_BAD_ATTRIBUTE:
            return "EGL_BAD_ATTRIBUTE";
        case EGL_BAD_CONTEXT:
            return "EGL_BAD_CONTEXT";
        case EGL_BAD_CONFIG:
            return "EGL_BAD_CONFIG";
        case EGL_BAD_CURRENT_SURFACE:
            return "EGL_BAD_CURRENT_SURFACE";
        case EGL_BAD_DISPLAY:
            return "EGL_BAD_DISPLAY";
        case EGL_BAD_SURFACE:
            return "EGL_BAD_SURFACE";
        case EGL_BAD_MATCH:
            return "EGL_BAD_MATCH";
        case EGL_BAD_PARAMETER:
            return "EGL_BAD_PARAMETER";
        case EGL_BAD_NATIVE_PIXMAP:
            return "EGL_BAD_NATIVE_PIXMAP";
        case EGL_BAD_NATIVE_WINDOW:
            return "EGL_BAD_NATIVE_WINDOW";
        case EGL_CONTEXT_LOST:
            return "EGL_CONTEXT_LOST";
        default:
            return "EGL_???";
    }
}

WaylandEgl::WaylandEgl(QObject* parent )
{
    connect(this, SIGNAL(windowChanged(QQuickWindow*)), this, SLOT(handleWindowChanged(QQuickWindow*)));
}

void WaylandEgl::handleWindowChanged(QQuickWindow *win)
{
    qDebug() << "function" << __FUNCTION__ << "line " << __LINE__;
    if (win)
    {
        qDebug() << "function" << __FUNCTION__ << "line " << __LINE__ << "win" << win;
        //connect(win, SIGNAL(afterRendering()), this, SLOT(paint()), Qt::DirectConnection);
        connect(window(), &QQuickWindow::afterRendering, this, &WaylandEgl::paint, Qt::DirectConnection);
        //connect(win, SIGNAL(beforeSynchronizing()), this, SLOT(sync()), Qt::DirectConnection);
        win->setClearBeforeRendering(false);
        qDebug() <<  "Visibility" << win->visibility();
        mwindow = win;
    }
}

void WaylandEgl::paint()
{
    qDebug() << "function" << __FUNCTION__ << "line " << __LINE__ << "win" << mwindow;

    performEglSetup();
}

void WaylandEgl::sync()
{
    qDebug() << "function" << __FUNCTION__ << "line " << __LINE__;
}

void WaylandEgl::cleanup()
{
    qDebug() << "function" << __FUNCTION__ << "line " << __LINE__;
}

int WaylandEgl::performEglSetup()
{
    return 0;

}






