#ifndef WL_EGL_H
#define WL_EGL_H

#include <QWindow>
#include <QQuickWindow>
#include <QOpenGLFunctions>
#include <QQuickItem>
#include <errno.h>
#include <fcntl.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#define EGL_EGLEXT_PROTOTYPES
#define GL_GLEXT_PROTOTYPES
//#include <gbm.h>
#include <EGL/egl.h>
#include <EGL/eglext.h>
#include <drm_fourcc.h>
#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>
#include <xf86drm.h>
#include <xf86drmMode.h>
#include <wayland-client.h>

#include <QObject>

class WaylandEgl : public QQuickItem
{
    Q_OBJECT
public:
    explicit WaylandEgl(QObject* parent = nullptr) ;
    //WaylandEgl();
    Q_INVOKABLE int performEglSetup();
    QQuickWindow * mwindow;


private slots:
    void handleWindowChanged(QQuickWindow *win);

public slots:
    void paint();
    void cleanup();
    void sync();
};


#endif // WL_EGL_H
